#include "TM1637Display.h"

int buzzPin= 2; // I/O-pin from buzzer connects here 
const int wpm = 20; // Morse speed in WPM
const int dotL = 1200/wpm; // Calculated dot-length
const int dashL = 3*dotL; // Dash = 3 x dot
const int sPause = dotL; // Symbol pause = 1 dot
const int lPause = dashL; // Letter pause = 3 dots
const int wPause = 7*dotL; // Word pause = 7 dots

int rightStatusa=0;
int rightStatusPreva=1;
int rightStatus=0;
int rightStatusPrev=1;
#define first 2000
#define CLK 4
#define DIO 5
#define TEST_DELAY   1000
TM1637Display display(CLK, DIO);
int count = first;uint8_t data[] = {0, 0, 0, 0};
void setup()
  {
  Serial.begin(9600);
  pinMode(7,INPUT_PULLUP);
  pinMode(6,INPUT_PULLUP);
  pinMode(buzzPin,OUTPUT); // Set buzzer-pin as output
  }

void loop() {
  rightStatus=digitalRead(7);
  while (rightStatus!=rightStatusPrev && rightStatus==LOW) 
  {
    Serial.print("SWITCH RELEASED");
     counting();
  }
}
void counting () {
  rightStatusa=digitalRead(6);
  if (rightStatusa!=rightStatusPreva && rightStatusa==LOW) {
    Serial.print("SWITCH RELEASED");
    win();
    };
  display.setBrightness(0x0f);
  data[3] = display.encodeDigit(count/1 % 10);
  data[2] = display.encodeDigit(count/10 % 6);
  data[1] = display.encodeDigit(count/100 % 10);
  data[0] = display.encodeDigit(count/1000 % 10);
  display.setSegments(data);
  if(count >= first) {
       const int buzzer = 2;
    pinMode(buzzer, OUTPUT);
    delay(50);
    pinMode(buzzer, LOW);
    delay(50);
    pinMode(buzzer, OUTPUT);
    delay(50);
    pinMode(buzzer, LOW);
    delay(50);
    }
   if(count <= 10) {
      const int buzzer = 2;
    pinMode(buzzer, OUTPUT);
    delay(50);
    pinMode(buzzer, LOW);
    delay(50);
      }
  if(count <= 0) {lose();}
    else {count--;}
  delay(TEST_DELAY);
};
void lose() {
  display.setBrightness(0x0f);
  data[3] = display.encodeDigit(8);
  data[2] = display.encodeDigit(8);
  data[1] = display.encodeDigit(8);
  data[0] = display.encodeDigit(8);
  display.setSegments(data);
  const int buzzer = 2;
  pinMode(buzzer, OUTPUT);
  delay(500);
  display.setBrightness(0x0f);
  data[3] = display.encodeDigit(8);
  data[2] = display.encodeDigit(8);
  data[1] = display.encodeDigit(8);
  data[0] = display.encodeDigit(8);
  display.setSegments(data);
};

const uint8_t SEG_DONE[]=
{
  SEG_B | SEG_C | SEG_D | SEG_E | SEG_G,
  SEG_A | SEG_B | SEG_C | SEG_D | SEG_E | SEG_F,
  SEG_C | SEG_E | SEG_G,
  SEG_A | SEG_D | SEG_E | SEG_F | SEG_G,
};

void dot()
{
   digitalWrite(buzzPin, LOW); // Tone ON
   delay(dotL); // Tone length
   digitalWrite(buzzPin, HIGH); // Tone OFF
   delay(sPause); // Symbol pause
   return;
};

void dash()
{
  digitalWrite(buzzPin, LOW); // Tone ON
  delay(dashL); // Tone length
  digitalWrite(buzzPin, HIGH); // Tone OFF
  delay(sPause); // Symbol pause
  return;
};

void win() 
{
  int i=0;
  const int wpm = 20; // Morse speed in WPM
  const int dotL = 1200/wpm; // Calculated dot-length
  const int dashL = 3*dotL; // Dash = 3 x dot
  const int sPause = dotL; // Symbol pause = 1 dot
  const int lPause = dashL; // Letter pause = 3 dots
  const int wPause = 7*dotL; // Word pause = 7 dots
  pinMode(buzzPin,OUTPUT); // Set buzzer-pin as output
    while (i<1){
      display.setBrightness(0x0f);
      display.setSegments(SEG_DONE);
      dash();
      dot();
      dash();
      dot();
      delay(lPause-sPause); // Subtracts pause already taken
      dash();
      dash();
      dot();
      dash();
      delay(wPause-sPause); // Subtracts pause already taken
        };  
};
